/** @license React vundefined
 * react-dom-server.browser.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function(){(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactDOMServer = {}, global.React));
}(this, (function (exports, React) { 'use strict';

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   */
  // Do not require this module directly! Use normal `invariant` calls with
  // template literal strings. The messages will be replaced with error codes
  // during build.
  function formatProdErrorMessage(code) {
    let url = 'https://reactjs.org/docs/error-decoder.html?invariant=' + code;

    for (let i = 1; i < arguments.length; i++) {
      url += '&args[]=' + encodeURIComponent(arguments[i]);
    }

    return "Minified React error #" + code + "; visit " + url + " for the full message or " + 'use the non-minified dev environment for full errors and additional ' + 'helpful warnings.';
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  // TODO: this is special because it gets imported during build.
  var ReactVersion = '17.0.0';

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  const ReactInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
  var _assign = ReactInternals.assign;

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  let REACT_PORTAL_TYPE = 0xeaca;
  let REACT_FRAGMENT_TYPE = 0xeacb;
  let REACT_STRICT_MODE_TYPE = 0xeacc;
  let REACT_PROFILER_TYPE = 0xead2;
  let REACT_PROVIDER_TYPE = 0xeacd;
  let REACT_CONTEXT_TYPE = 0xeace;
  let REACT_FORWARD_REF_TYPE = 0xead0;
  let REACT_SUSPENSE_TYPE = 0xead1;
  let REACT_SUSPENSE_LIST_TYPE = 0xead8;
  let REACT_MEMO_TYPE = 0xead3;
  let REACT_LAZY_TYPE = 0xead4;
  let REACT_BLOCK_TYPE = 0xead9;
  let REACT_FUNDAMENTAL_TYPE = 0xead5;
  let REACT_SCOPE_TYPE = 0xead7;
  let REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
  let REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

  if (typeof Symbol === 'function' && Symbol.for) {
    const symbolFor = Symbol.for;
    REACT_PORTAL_TYPE = symbolFor('react.portal');
    REACT_FRAGMENT_TYPE = symbolFor('react.fragment');
    REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
    REACT_PROFILER_TYPE = symbolFor('react.profiler');
    REACT_PROVIDER_TYPE = symbolFor('react.provider');
    REACT_CONTEXT_TYPE = symbolFor('react.context');
    REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
    REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
    REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
    REACT_MEMO_TYPE = symbolFor('react.memo');
    REACT_LAZY_TYPE = symbolFor('react.lazy');
    REACT_BLOCK_TYPE = symbolFor('react.block');
    REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
    REACT_SCOPE_TYPE = symbolFor('react.scope');
    REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
    REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */

  function getWrappedName(outerType, innerType, wrapperName) {
    const functionName = innerType.displayName || innerType.name || '';
    return outerType.displayName || (functionName !== '' ? wrapperName + "(" + functionName + ")" : wrapperName);
  }

  function getContextName(type) {
    return type.displayName || 'Context';
  }

  function getComponentName(type) {
    if (type == null) {
      // Host root, text node or just invalid type.
      return null;
    }

    if (typeof type === 'function') {
      return type.displayName || type.name || null;
    }

    if (typeof type === 'string') {
      return type;
    }

    switch (type) {
      case REACT_FRAGMENT_TYPE:
        return 'Fragment';

      case REACT_PORTAL_TYPE:
        return 'Portal';

      case REACT_PROFILER_TYPE:
        return 'Profiler';

      case REACT_STRICT_MODE_TYPE:
        return 'StrictMode';

      case REACT_SUSPENSE_TYPE:
        return 'Suspense';

      case REACT_SUSPENSE_LIST_TYPE:
        return 'SuspenseList';
    }

    if (typeof type === 'object') {
      switch (type.$$typeof) {
        case REACT_CONTEXT_TYPE:
          const context = type;
          return getContextName(context) + '.Consumer';

        case REACT_PROVIDER_TYPE:
          const provider = type;
          return getContextName(provider._context) + '.Provider';

        case REACT_FORWARD_REF_TYPE:
          return getWrappedName(type, type.render, 'ForwardRef');

        case REACT_MEMO_TYPE:
          return getComponentName(type.type);

        case REACT_BLOCK_TYPE:
          return getComponentName(type._render);

        case REACT_LAZY_TYPE:
          {
            const lazyComponent = type;
            const payload = lazyComponent._payload;
            const init = lazyComponent._init;

            try {
              return getComponentName(init(payload));
            } catch (x) {
              return null;
            }
          }
      }
    }

    return null;
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */

  const enableSuspenseServerRenderer = true;

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  const ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  const ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  const ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */

  const emptyObject = {};

  function maskContext(type, context) {
    const contextTypes = type.contextTypes;

    if (!contextTypes) {
      return emptyObject;
    }

    const maskedContext = {};

    for (const contextName in contextTypes) {
      maskedContext[contextName] = context[contextName];
    }

    return maskedContext;
  }

  function validateContextBounds(context, threadID) {
    // If we don't have enough slots in this context to store this threadID,
    // fill it in without leaving any holes to ensure that the VM optimizes
    // this as non-holey index properties.
    // (Note: If `react` package is < 16.6, _threadCount is undefined.)
    for (let i = context._threadCount | 0; i <= threadID; i++) {
      // We assume that this is the same as the defaultValue which might not be
      // true if we're rendering inside a secondary renderer but they are
      // secondary because these use cases are very rare.
      context[i] = context._currentValue2;
      context._threadCount = i + 1;
    }
  }
  function processContext(type, context, threadID, isClass) {
    if (isClass) {
      const contextType = type.contextType;

      if (typeof contextType === 'object' && contextType !== null) {
        validateContextBounds(contextType, threadID);
        return contextType[threadID];
      }

      {
        const maskedContext = maskContext(type, context);

        return maskedContext;
      }
    } else {
      {
        const maskedContext = maskContext(type, context);

        return maskedContext;
      }
    }
  }

  let nextAvailableThreadIDs = new Uint16Array(16);

  for (let i = 0; i < 15; i++) {
    nextAvailableThreadIDs[i] = i + 1;
  }

  nextAvailableThreadIDs[15] = 0;

  function growThreadCountAndReturnNextAvailable() {
    const oldArray = nextAvailableThreadIDs;
    const oldSize = oldArray.length;
    const newSize = oldSize * 2;

    if (!(newSize <= 0x10000)) {
      {
        throw Error( formatProdErrorMessage(304));
      }
    }

    const newArray = new Uint16Array(newSize);
    newArray.set(oldArray);
    nextAvailableThreadIDs = newArray;
    nextAvailableThreadIDs[0] = oldSize + 1;

    for (let i = oldSize; i < newSize - 1; i++) {
      nextAvailableThreadIDs[i] = i + 1;
    }

    nextAvailableThreadIDs[newSize - 1] = 0;
    return oldSize;
  }

  function allocThreadID() {
    const nextID = nextAvailableThreadIDs[0];

    if (nextID === 0) {
      return growThreadCountAndReturnNextAvailable();
    }

    nextAvailableThreadIDs[0] = nextAvailableThreadIDs[nextID];
    return nextID;
  }
  function freeThreadID(id) {
    nextAvailableThreadIDs[id] = nextAvailableThreadIDs[0];
    nextAvailableThreadIDs[0] = id;
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  // A reserved attribute.
  // It is handled by React separately and shouldn't be written to the DOM.
  const RESERVED = 0; // A simple string attribute.
  // Attributes that aren't in the filter are presumed to have this type.

  const STRING = 1; // A string attribute that accepts booleans in React. In HTML, these are called
  // "enumerated" attributes with "true" and "false" as possible values.
  // When true, it should be set to a "true" string.
  // When false, it should be set to a "false" string.

  const BOOLEANISH_STRING = 2; // A real boolean attribute.
  // When true, it should be present (set either to an empty string or its name).
  // When false, it should be omitted.

  const BOOLEAN = 3; // An attribute that can be used as a flag as well as with a value.
  // When true, it should be present (set either to an empty string or its name).
  // When false, it should be omitted.
  // For any other value, should be present with that value.

  const OVERLOADED_BOOLEAN = 4; // An attribute that must be numeric or parse as a numeric.
  // When falsy, it should be removed.

  const NUMERIC = 5; // An attribute that must be positive numeric or parse as a positive numeric.
  // When falsy, it should be removed.

  const POSITIVE_NUMERIC = 6;

  /* eslint-disable max-len */
  const ATTRIBUTE_NAME_START_CHAR = ':A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD';
  /* eslint-enable max-len */

  const ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + '\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040';
  const ROOT_ATTRIBUTE_NAME = 'data-reactroot';
  const VALID_ATTRIBUTE_NAME_REGEX = new RegExp('^[' + ATTRIBUTE_NAME_START_CHAR + '][' + ATTRIBUTE_NAME_CHAR + ']*$');
  const hasOwnProperty = Object.prototype.hasOwnProperty;
  const illegalAttributeNameCache = {};
  const validatedAttributeNameCache = {};
  function isAttributeNameSafe(attributeName) {
    if (hasOwnProperty.call(validatedAttributeNameCache, attributeName)) {
      return true;
    }

    if (hasOwnProperty.call(illegalAttributeNameCache, attributeName)) {
      return false;
    }

    if (VALID_ATTRIBUTE_NAME_REGEX.test(attributeName)) {
      validatedAttributeNameCache[attributeName] = true;
      return true;
    }

    illegalAttributeNameCache[attributeName] = true;

    return false;
  }
  function shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag) {
    if (propertyInfo !== null) {
      return propertyInfo.type === RESERVED;
    }

    if (isCustomComponentTag) {
      return false;
    }

    if (name.length > 2 && (name[0] === 'o' || name[0] === 'O') && (name[1] === 'n' || name[1] === 'N')) {
      return true;
    }

    return false;
  }
  function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
    if (propertyInfo !== null && propertyInfo.type === RESERVED) {
      return false;
    }

    switch (typeof value) {
      case 'function': // $FlowIssue symbol is perfectly valid here

      case 'symbol':
        // eslint-disable-line
        return true;

      case 'boolean':
        {
          if (isCustomComponentTag) {
            return false;
          }

          if (propertyInfo !== null) {
            return !propertyInfo.acceptsBooleans;
          } else {
            const prefix = name.toLowerCase().slice(0, 5);
            return prefix !== 'data-' && prefix !== 'aria-';
          }
        }

      default:
        return false;
    }
  }
  function shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag) {
    if (value === null || typeof value === 'undefined') {
      return true;
    }

    if (shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag)) {
      return true;
    }

    if (isCustomComponentTag) {
      return false;
    }

    if (propertyInfo !== null) {

      switch (propertyInfo.type) {
        case BOOLEAN:
          return !value;

        case OVERLOADED_BOOLEAN:
          return value === false;

        case NUMERIC:
          return isNaN(value);

        case POSITIVE_NUMERIC:
          return isNaN(value) || value < 1;
      }
    }

    return false;
  }
  function getPropertyInfo(name) {
    return properties.hasOwnProperty(name) ? properties[name] : null;
  }

  function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL, removeEmptyString) {
    this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN;
    this.attributeName = attributeName;
    this.attributeNamespace = attributeNamespace;
    this.mustUseProperty = mustUseProperty;
    this.propertyName = name;
    this.type = type;
    this.sanitizeURL = sanitizeURL;
    this.removeEmptyString = removeEmptyString;
  } // When adding attributes to this list, be sure to also add them to
  // the `possibleStandardNames` module to ensure casing and incorrect
  // name warnings.


  const properties = {}; // These props are reserved by React. They shouldn't be written to the DOM.

  const reservedProps = ['children', 'dangerouslySetInnerHTML', // TODO: This prevents the assignment of defaultValue to regular
  // elements (not just inputs). Now that ReactDOMInput assigns to the
  // defaultValue property -- do we need this?
  'defaultValue', 'defaultChecked', 'innerHTML', 'suppressContentEditableWarning', 'suppressHydrationWarning', 'style'];
  reservedProps.forEach(name => {
    properties[name] = new PropertyInfoRecord(name, RESERVED, false, // mustUseProperty
    name, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // A few React string attributes have a different name.
  // This is a mapping from React prop names to the attribute names.

  [['acceptCharset', 'accept-charset'], ['className', 'class'], ['htmlFor', 'for'], ['httpEquiv', 'http-equiv']].forEach((_ref) => {
    let name = _ref[0],
        attributeName = _ref[1];
    properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    attributeName, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are "enumerated" HTML attributes that accept "true" and "false".
  // In React, we let users pass `true` and `false` even though technically
  // these aren't boolean attributes (they are coerced to strings).

  ['contentEditable', 'draggable', 'spellCheck', 'value'].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, BOOLEANISH_STRING, false, // mustUseProperty
    name.toLowerCase(), // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are "enumerated" SVG attributes that accept "true" and "false".
  // In React, we let users pass `true` and `false` even though technically
  // these aren't boolean attributes (they are coerced to strings).
  // Since these are SVG attributes, their attribute names are case-sensitive.

  ['autoReverse', 'externalResourcesRequired', 'focusable', 'preserveAlpha'].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, BOOLEANISH_STRING, false, // mustUseProperty
    name, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are HTML boolean attributes.

  ['allowFullScreen', 'async', // Note: there is a special case that prevents it from being written to the DOM
  // on the client side because the browsers are inconsistent. Instead we call focus().
  'autoFocus', 'autoPlay', 'controls', 'default', 'defer', 'disabled', 'disablePictureInPicture', 'disableRemotePlayback', 'formNoValidate', 'hidden', 'loop', 'noModule', 'noValidate', 'open', 'playsInline', 'readOnly', 'required', 'reversed', 'scoped', 'seamless', // Microdata
  'itemScope'].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, BOOLEAN, false, // mustUseProperty
    name.toLowerCase(), // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are the few React props that we set as DOM properties
  // rather than attributes. These are all booleans.

  ['checked', // Note: `option.selected` is not updated if `select.multiple` is
  // disabled with `removeAttribute`. We have special logic for handling this.
  'multiple', 'muted', 'selected' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, BOOLEAN, true, // mustUseProperty
    name, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are HTML attributes that are "overloaded booleans": they behave like
  // booleans, but can also accept a string value.

  ['capture', 'download' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, OVERLOADED_BOOLEAN, false, // mustUseProperty
    name, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are HTML attributes that must be positive numbers.

  ['cols', 'rows', 'size', 'span' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, POSITIVE_NUMERIC, false, // mustUseProperty
    name, // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These are HTML attributes that must be numbers.

  ['rowSpan', 'start'].forEach(name => {
    properties[name] = new PropertyInfoRecord(name, NUMERIC, false, // mustUseProperty
    name.toLowerCase(), // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  });
  const CAMELIZE = /[\-\:]([a-z])/g;

  const capitalize = token => token[1].toUpperCase(); // This is a list of all SVG attributes that need special casing, namespacing,
  // or boolean value assignment. Regular attributes that just accept strings
  // and have the same names are omitted, just like in the HTML attribute filter.
  // Some of these attributes can be hard to find. This list was created by
  // scraping the MDN documentation.


  ['accent-height', 'alignment-baseline', 'arabic-form', 'baseline-shift', 'cap-height', 'clip-path', 'clip-rule', 'color-interpolation', 'color-interpolation-filters', 'color-profile', 'color-rendering', 'dominant-baseline', 'enable-background', 'fill-opacity', 'fill-rule', 'flood-color', 'flood-opacity', 'font-family', 'font-size', 'font-size-adjust', 'font-stretch', 'font-style', 'font-variant', 'font-weight', 'glyph-name', 'glyph-orientation-horizontal', 'glyph-orientation-vertical', 'horiz-adv-x', 'horiz-origin-x', 'image-rendering', 'letter-spacing', 'lighting-color', 'marker-end', 'marker-mid', 'marker-start', 'overline-position', 'overline-thickness', 'paint-order', 'panose-1', 'pointer-events', 'rendering-intent', 'shape-rendering', 'stop-color', 'stop-opacity', 'strikethrough-position', 'strikethrough-thickness', 'stroke-dasharray', 'stroke-dashoffset', 'stroke-linecap', 'stroke-linejoin', 'stroke-miterlimit', 'stroke-opacity', 'stroke-width', 'text-anchor', 'text-decoration', 'text-rendering', 'underline-position', 'underline-thickness', 'unicode-bidi', 'unicode-range', 'units-per-em', 'v-alphabetic', 'v-hanging', 'v-ideographic', 'v-mathematical', 'vector-effect', 'vert-adv-y', 'vert-origin-x', 'vert-origin-y', 'word-spacing', 'writing-mode', 'xmlns:xlink', 'x-height' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(attributeName => {
    const name = attributeName.replace(CAMELIZE, capitalize);
    properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    attributeName, null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // String SVG attributes with the xlink namespace.

  ['xlink:actuate', 'xlink:arcrole', 'xlink:role', 'xlink:show', 'xlink:title', 'xlink:type' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(attributeName => {
    const name = attributeName.replace(CAMELIZE, capitalize);
    properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    attributeName, 'http://www.w3.org/1999/xlink', false, // sanitizeURL
    false);
  }); // String SVG attributes with the xml namespace.

  ['xml:base', 'xml:lang', 'xml:space' // NOTE: if you add a camelCased prop to this list,
  // you'll need to set attributeName to name.toLowerCase()
  // instead in the assignment below.
  ].forEach(attributeName => {
    const name = attributeName.replace(CAMELIZE, capitalize);
    properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    attributeName, 'http://www.w3.org/XML/1998/namespace', false, // sanitizeURL
    false);
  }); // These attribute exists both in HTML and SVG.
  // The attribute name is case-sensitive in SVG so we can't just use
  // the React name like we do for attributes that exist only in HTML.

  ['tabIndex', 'crossOrigin'].forEach(attributeName => {
    properties[attributeName] = new PropertyInfoRecord(attributeName, STRING, false, // mustUseProperty
    attributeName.toLowerCase(), // attributeName
    null, // attributeNamespace
    false, // sanitizeURL
    false);
  }); // These attributes accept URLs. These must not allow javascript: URLS.
  // These will also need to accept Trusted Types object in the future.

  const xlinkHref = 'xlinkHref';
  properties[xlinkHref] = new PropertyInfoRecord('xlinkHref', STRING, false, // mustUseProperty
  'xlink:href', 'http://www.w3.org/1999/xlink', true, // sanitizeURL
  false);
  ['src', 'href', 'action', 'formAction'].forEach(attributeName => {
    properties[attributeName] = new PropertyInfoRecord(attributeName, STRING, false, // mustUseProperty
    attributeName.toLowerCase(), // attributeName
    null, // attributeNamespace
    true, // sanitizeURL
    true);
  });

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * Based on the escape-html library, which is used under the MIT License below:
   *
   * Copyright (c) 2012-2013 TJ Holowaychuk
   * Copyright (c) 2015 Andreas Lubbe
   * Copyright (c) 2015 Tiancheng "Timothy" Gu
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * 'Software'), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
   * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
   */
  // code copied and modified from escape-html

  /**
   * Module variables.
   * @private
   */
  const matchHtmlRegExp = /["'&<>]/;
  /**
   * Escapes special characters and HTML entities in a given html string.
   *
   * @param  {string} string HTML string to escape for later insertion
   * @return {string}
   * @public
   */

  function escapeHtml(string) {
    const str = '' + string;
    const match = matchHtmlRegExp.exec(str);

    if (!match) {
      return str;
    }

    let escape;
    let html = '';
    let index;
    let lastIndex = 0;

    for (index = match.index; index < str.length; index++) {
      switch (str.charCodeAt(index)) {
        case 34:
          // "
          escape = '&quot;';
          break;

        case 38:
          // &
          escape = '&amp;';
          break;

        case 39:
          // '
          escape = '&#x27;'; // modified from escape-html; used to be '&#39'

          break;

        case 60:
          // <
          escape = '&lt;';
          break;

        case 62:
          // >
          escape = '&gt;';
          break;

        default:
          continue;
      }

      if (lastIndex !== index) {
        html += str.substring(lastIndex, index);
      }

      lastIndex = index + 1;
      html += escape;
    }

    return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
  } // end code copied and modified from escape-html

  /**
   * Escapes text to prevent scripting attacks.
   *
   * @param {*} text Text value to escape.
   * @return {string} An escaped string.
   */


  function escapeTextForBrowser(text) {
    if (typeof text === 'boolean' || typeof text === 'number') {
      // this shortcircuit helps perf for types that we know will never have
      // special characters, especially given that this function is used often
      // for numeric dom ids.
      return '' + text;
    }

    return escapeHtml(text);
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  /**
   * Escapes attribute value to prevent scripting attacks.
   *
   * @param {*} value Value to escape.
   * @return {string} An escaped string.
   */

  function quoteAttributeValueForBrowser(value) {
    return '"' + escapeTextForBrowser(value) + '"';
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  function createMarkupForRoot() {
    return ROOT_ATTRIBUTE_NAME + '=""';
  }
  /**
   * Creates markup for a property.
   *
   * @param {string} name
   * @param {*} value
   * @return {?string} Markup string, or null if the property was invalid.
   */

  function createMarkupForProperty(name, value) {
    const propertyInfo = getPropertyInfo(name);

    if (name !== 'style' && shouldIgnoreAttribute(name, propertyInfo, false)) {
      return '';
    }

    if (shouldRemoveAttribute(name, value, propertyInfo, false)) {
      return '';
    }

    if (propertyInfo !== null) {
      const attributeName = propertyInfo.attributeName;
      const type = propertyInfo.type;

      if (type === BOOLEAN || type === OVERLOADED_BOOLEAN && value === true) {
        return attributeName + '=""';
      } else {
        if (propertyInfo.sanitizeURL) {
          value = '' + value;
        }

        return attributeName + '=' + quoteAttributeValueForBrowser(value);
      }
    } else if (isAttributeNameSafe(name)) {
      return name + '=' + quoteAttributeValueForBrowser(value);
    }

    return '';
  }
  /**
   * Creates markup for a custom property.
   *
   * @param {string} name
   * @param {*} value
   * @return {string} Markup string, or empty string if the property was invalid.
   */

  function createMarkupForCustomAttribute(name, value) {
    if (!isAttributeNameSafe(name) || value == null) {
      return '';
    }

    return name + '=' + quoteAttributeValueForBrowser(value);
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  function is(x, y) {
    return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y // eslint-disable-line no-self-compare
    ;
  }

  const objectIs = typeof Object.is === 'function' ? Object.is : is;

  let currentlyRenderingComponent = null;
  let firstWorkInProgressHook = null;
  let workInProgressHook = null; // Whether the work-in-progress hook is a re-rendered hook

  let isReRender = false; // Whether an update was scheduled during the currently executing render pass.

  let didScheduleRenderPhaseUpdate = false; // Lazily created map of render-phase updates

  let renderPhaseUpdates = null; // Counter to prevent infinite loops.

  let numberOfReRenders = 0;
  const RE_RENDER_LIMIT = 25;

  function resolveCurrentlyRenderingComponent() {
    if (!(currentlyRenderingComponent !== null)) {
      {
        throw Error( formatProdErrorMessage(321));
      }
    }

    return currentlyRenderingComponent;
  }

  function areHookInputsEqual(nextDeps, prevDeps) {
    if (prevDeps === null) {

      return false;
    }

    for (let i = 0; i < prevDeps.length && i < nextDeps.length; i++) {
      if (objectIs(nextDeps[i], prevDeps[i])) {
        continue;
      }

      return false;
    }

    return true;
  }

  function createHook() {
    if (numberOfReRenders > 0) {
      {
        {
          throw Error( formatProdErrorMessage(312));
        }
      }
    }

    return {
      memoizedState: null,
      queue: null,
      next: null
    };
  }

  function createWorkInProgressHook() {
    if (workInProgressHook === null) {
      // This is the first hook in the list
      if (firstWorkInProgressHook === null) {
        isReRender = false;
        firstWorkInProgressHook = workInProgressHook = createHook();
      } else {
        // There's already a work-in-progress. Reuse it.
        isReRender = true;
        workInProgressHook = firstWorkInProgressHook;
      }
    } else {
      if (workInProgressHook.next === null) {
        isReRender = false; // Append to the end of the list

        workInProgressHook = workInProgressHook.next = createHook();
      } else {
        // There's already a work-in-progress. Reuse it.
        isReRender = true;
        workInProgressHook = workInProgressHook.next;
      }
    }

    return workInProgressHook;
  }

  function prepareToUseHooks(componentIdentity) {
    currentlyRenderingComponent = componentIdentity;
    // didScheduleRenderPhaseUpdate = false;
    // firstWorkInProgressHook = null;
    // numberOfReRenders = 0;
    // renderPhaseUpdates = null;
    // workInProgressHook = null;

  }
  function finishHooks(Component, props, children, refOrContext) {
    // This must be called after every function component to prevent hooks from
    // being used in classes.
    while (didScheduleRenderPhaseUpdate) {
      // Updates were scheduled during the render phase. They are stored in
      // the `renderPhaseUpdates` map. Call the component again, reusing the
      // work-in-progress hooks and applying the additional updates on top. Keep
      // restarting until no more updates are scheduled.
      didScheduleRenderPhaseUpdate = false;
      numberOfReRenders += 1; // Start over from the beginning of the list

      workInProgressHook = null;
      children = Component(props, refOrContext);
    }

    resetHooksState();
    return children;
  } // Reset the internal hooks state if an error occurs while rendering a component

  function resetHooksState() {

    currentlyRenderingComponent = null;
    didScheduleRenderPhaseUpdate = false;
    firstWorkInProgressHook = null;
    numberOfReRenders = 0;
    renderPhaseUpdates = null;
    workInProgressHook = null;
  }

  function readContext(context, observedBits) {
    const threadID = currentPartialRenderer.threadID;
    validateContextBounds(context, threadID);

    return context[threadID];
  }

  function useContext(context, observedBits) {

    resolveCurrentlyRenderingComponent();
    const threadID = currentPartialRenderer.threadID;
    validateContextBounds(context, threadID);
    return context[threadID];
  }

  function basicStateReducer(state, action) {
    // $FlowFixMe: Flow doesn't like mixed types
    return typeof action === 'function' ? action(state) : action;
  }

  function useState(initialState) {

    return useReducer(basicStateReducer, // useReducer has a special case to support lazy useState initializers
    initialState);
  }
  function useReducer(reducer, initialArg, init) {

    currentlyRenderingComponent = resolveCurrentlyRenderingComponent();
    workInProgressHook = createWorkInProgressHook();

    if (isReRender) {
      // This is a re-render. Apply the new render phase updates to the previous
      // current hook.
      const queue = workInProgressHook.queue;
      const dispatch = queue.dispatch;

      if (renderPhaseUpdates !== null) {
        // Render phase updates are stored in a map of queue -> linked list
        const firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);

        if (firstRenderPhaseUpdate !== undefined) {
          renderPhaseUpdates.delete(queue);
          let newState = workInProgressHook.memoizedState;
          let update = firstRenderPhaseUpdate;

          do {
            // Process this render phase update. We don't have to check the
            // priority because it will always be the same as the current
            // render's.
            const action = update.action;

            newState = reducer(newState, action);

            update = update.next;
          } while (update !== null);

          workInProgressHook.memoizedState = newState;
          return [newState, dispatch];
        }
      }

      return [workInProgressHook.memoizedState, dispatch];
    } else {

      let initialState;

      if (reducer === basicStateReducer) {
        // Special case for `useState`.
        initialState = typeof initialArg === 'function' ? initialArg() : initialArg;
      } else {
        initialState = init !== undefined ? init(initialArg) : initialArg;
      }

      workInProgressHook.memoizedState = initialState;
      const queue = workInProgressHook.queue = {
        last: null,
        dispatch: null
      };
      const dispatch = queue.dispatch = dispatchAction.bind(null, currentlyRenderingComponent, queue);
      return [workInProgressHook.memoizedState, dispatch];
    }
  }

  function useMemo(nextCreate, deps) {
    currentlyRenderingComponent = resolveCurrentlyRenderingComponent();
    workInProgressHook = createWorkInProgressHook();
    const nextDeps = deps === undefined ? null : deps;

    if (workInProgressHook !== null) {
      const prevState = workInProgressHook.memoizedState;

      if (prevState !== null) {
        if (nextDeps !== null) {
          const prevDeps = prevState[1];

          if (areHookInputsEqual(nextDeps, prevDeps)) {
            return prevState[0];
          }
        }
      }
    }

    const nextValue = nextCreate();

    workInProgressHook.memoizedState = [nextValue, nextDeps];
    return nextValue;
  }

  function useRef(initialValue) {
    currentlyRenderingComponent = resolveCurrentlyRenderingComponent();
    workInProgressHook = createWorkInProgressHook();
    const previousRef = workInProgressHook.memoizedState;

    if (previousRef === null) {
      const ref = {
        current: initialValue
      };

      workInProgressHook.memoizedState = ref;
      return ref;
    } else {
      return previousRef;
    }
  }

  function useLayoutEffect(create, inputs) {
  }

  function dispatchAction(componentIdentity, queue, action) {
    if (!(numberOfReRenders < RE_RENDER_LIMIT)) {
      {
        throw Error( formatProdErrorMessage(301));
      }
    }

    if (componentIdentity === currentlyRenderingComponent) {
      // This is a render phase update. Stash it in a lazily-created map of
      // queue -> linked list of updates. After this render pass, we'll restart
      // and apply the stashed updates on top of the work-in-progress hook.
      didScheduleRenderPhaseUpdate = true;
      const update = {
        action,
        next: null
      };

      if (renderPhaseUpdates === null) {
        renderPhaseUpdates = new Map();
      }

      const firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);

      if (firstRenderPhaseUpdate === undefined) {
        renderPhaseUpdates.set(queue, update);
      } else {
        // Append the update to the end of the list.
        let lastRenderPhaseUpdate = firstRenderPhaseUpdate;

        while (lastRenderPhaseUpdate.next !== null) {
          lastRenderPhaseUpdate = lastRenderPhaseUpdate.next;
        }

        lastRenderPhaseUpdate.next = update;
      }
    }
  }

  function useCallback(callback, deps) {
    return useMemo(() => callback, deps);
  } // TODO Decide on how to implement this hook for server rendering.
  // If a mutation occurs during render, consider triggering a Suspense boundary
  // and falling back to client rendering.

  function useMutableSource(source, getSnapshot, subscribe) {
    resolveCurrentlyRenderingComponent();
    return getSnapshot(source._source);
  }

  function useDeferredValue(value) {
    resolveCurrentlyRenderingComponent();
    return value;
  }

  function useTransition() {
    resolveCurrentlyRenderingComponent();

    const startTransition = callback => {
      callback();
    };

    return [startTransition, false];
  }

  function useOpaqueIdentifier() {
    return (currentPartialRenderer.identifierPrefix || '') + 'R:' + (currentPartialRenderer.uniqueID++).toString(36);
  }

  function noop() {}

  let currentPartialRenderer = null;
  function setCurrentPartialRenderer(renderer) {
    currentPartialRenderer = renderer;
  }
  const Dispatcher = {
    readContext,
    useContext,
    useMemo,
    useReducer,
    useRef,
    useState,
    useLayoutEffect,
    useCallback,
    // useImperativeHandle is not run in the server environment
    useImperativeHandle: noop,
    // Effects are not run in the server environment.
    useEffect: noop,
    // Debugging effect
    useDebugValue: noop,
    useDeferredValue,
    useTransition,
    useOpaqueIdentifier,
    // Subscriptions are not setup in a server environment.
    useMutableSource
  };

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  const HTML_NAMESPACE = 'http://www.w3.org/1999/xhtml';
  const MATH_NAMESPACE = 'http://www.w3.org/1998/Math/MathML';
  const SVG_NAMESPACE = 'http://www.w3.org/2000/svg';
  const Namespaces = {
    html: HTML_NAMESPACE,
    mathml: MATH_NAMESPACE,
    svg: SVG_NAMESPACE
  }; // Assumes there is no parent namespace.

  function getIntrinsicNamespace(type) {
    switch (type) {
      case 'svg':
        return SVG_NAMESPACE;

      case 'math':
        return MATH_NAMESPACE;

      default:
        return HTML_NAMESPACE;
    }
  }
  function getChildNamespace(parentNamespace, type) {
    if (parentNamespace == null || parentNamespace === HTML_NAMESPACE) {
      // No (or default) parent namespace: potential entry point.
      return getIntrinsicNamespace(type);
    }

    if (parentNamespace === SVG_NAMESPACE && type === 'foreignObject') {
      // We're leaving SVG.
      return HTML_NAMESPACE;
    } // By default, pass namespace below.


    return parentNamespace;
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  // For HTML, certain tags should omit their close tag. We keep a list for
  // those special-case tags.
  const omittedCloseTags = {
    area: true,
    base: true,
    br: true,
    col: true,
    embed: true,
    hr: true,
    img: true,
    input: true,
    keygen: true,
    link: true,
    meta: true,
    param: true,
    source: true,
    track: true,
    wbr: true // NOTE: menuitem's close tag should be omitted, but that causes problems.

  };

  // `omittedCloseTags` except that `menuitem` should still have its closing tag.

  const voidElementTags = _assign({
    menuitem: true
  }, omittedCloseTags);

  const HTML = '__html';

  function assertValidProps(tag, props) {
    if (!props) {
      return;
    } // Note the use of `==` which checks for null or undefined.


    if (voidElementTags[tag]) {
      if (!(props.children == null && props.dangerouslySetInnerHTML == null)) {
        {
          throw Error( formatProdErrorMessage(137, tag));
        }
      }
    }

    if (props.dangerouslySetInnerHTML != null) {
      if (!(props.children == null)) {
        {
          throw Error( formatProdErrorMessage(60));
        }
      }

      if (!(typeof props.dangerouslySetInnerHTML === 'object' && HTML in props.dangerouslySetInnerHTML)) {
        {
          throw Error( formatProdErrorMessage(61));
        }
      }
    }

    if (!(props.style == null || typeof props.style === 'object')) {
      {
        throw Error( formatProdErrorMessage(62));
      }
    }
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  /**
   * CSS properties which accept numbers but are not in units of "px".
   */
  const isUnitlessNumber = {
    animationIterationCount: true,
    borderImageOutset: true,
    borderImageSlice: true,
    borderImageWidth: true,
    boxFlex: true,
    boxFlexGroup: true,
    boxOrdinalGroup: true,
    columnCount: true,
    columns: true,
    flex: true,
    flexGrow: true,
    flexPositive: true,
    flexShrink: true,
    flexNegative: true,
    flexOrder: true,
    gridArea: true,
    gridRow: true,
    gridRowEnd: true,
    gridRowSpan: true,
    gridRowStart: true,
    gridColumn: true,
    gridColumnEnd: true,
    gridColumnSpan: true,
    gridColumnStart: true,
    fontWeight: true,
    lineClamp: true,
    lineHeight: true,
    opacity: true,
    order: true,
    orphans: true,
    tabSize: true,
    widows: true,
    zIndex: true,
    zoom: true,
    // SVG-related properties
    fillOpacity: true,
    floodOpacity: true,
    stopOpacity: true,
    strokeDasharray: true,
    strokeDashoffset: true,
    strokeMiterlimit: true,
    strokeOpacity: true,
    strokeWidth: true
  };
  /**
   * @param {string} prefix vendor-specific prefix, eg: Webkit
   * @param {string} key style name, eg: transitionDuration
   * @return {string} style name prefixed with `prefix`, properly camelCased, eg:
   * WebkitTransitionDuration
   */

  function prefixKey(prefix, key) {
    return prefix + key.charAt(0).toUpperCase() + key.substring(1);
  }
  /**
   * Support style names that may come passed in prefixed by adding permutations
   * of vendor prefixes.
   */


  const prefixes = ['Webkit', 'ms', 'Moz', 'O']; // Using Object.keys here, or else the vanilla for-in loop makes IE8 go into an
  // infinite loop, because it iterates over the newly added props too.

  Object.keys(isUnitlessNumber).forEach(function (prop) {
    prefixes.forEach(function (prefix) {
      isUnitlessNumber[prefixKey(prefix, prop)] = isUnitlessNumber[prop];
    });
  });

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  /**
   * Convert a value into the proper css writable value. The style name `name`
   * should be logical (no hyphens), as specified
   * in `CSSProperty.isUnitlessNumber`.
   *
   * @param {string} name CSS property name such as `topMargin`.
   * @param {*} value CSS property value such as `10px`.
   * @return {string} Normalized style value with dimensions applied.
   */

  function dangerousStyleValue(name, value, isCustomProperty) {
    // Note that we've removed escapeTextForBrowser() calls here since the
    // whole string will be escaped when the attribute is injected into
    // the markup. If you provide unsafe user data here they can inject
    // arbitrary CSS which may be problematic (I couldn't repro this):
    // https://www.owasp.org/index.php/XSS_Filter_Evasion_Cheat_Sheet
    // http://www.thespanner.co.uk/2007/11/26/ultimate-xss-css-injection/
    // This is not an XSS hole but instead a potential CSS injection issue
    // which has lead to a greater discussion about how we're going to
    // trust URLs moving forward. See #2115901
    const isEmpty = value == null || typeof value === 'boolean' || value === '';

    if (isEmpty) {
      return '';
    }

    if (!isCustomProperty && typeof value === 'number' && value !== 0 && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name])) {
      return value + 'px'; // Presumes implicit 'px' suffix for unitless numbers
    }

    return ('' + value).trim();
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  const uppercasePattern = /([A-Z])/g;
  const msPattern = /^ms-/;
  /**
   * Hyphenates a camelcased CSS property name, for example:
   *
   *   > hyphenateStyleName('backgroundColor')
   *   < "background-color"
   *   > hyphenateStyleName('MozTransition')
   *   < "-moz-transition"
   *   > hyphenateStyleName('msTransition')
   *   < "-ms-transition"
   *
   * As Modernizr suggests (http://modernizr.com/docs/#prefixed), an `ms` prefix
   * is converted to `-ms-`.
   */

  function hyphenateStyleName(name) {
    return name.replace(uppercasePattern, '-$1').toLowerCase().replace(msPattern, '-ms-');
  }

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *
   * 
   */
  function isCustomComponent(tagName, props) {
    if (tagName.indexOf('-') === -1) {
      return typeof props.is === 'string';
    }

    switch (tagName) {
      // These are reserved SVG and MathML elements.
      // We don't mind this list too much because we expect it to never grow.
      // The alternative is to track the namespace in a few places which is convoluted.
      // https://w3c.github.io/webcomponents/spec/custom/#custom-elements-core-concepts
      case 'annotation-xml':
      case 'color-profile':
      case 'font-face':
      case 'font-face-src':
      case 'font-face-uri':
      case 'font-face-format':
      case 'font-face-name':
      case 'missing-glyph':
        return false;

      default:
        return true;
    }
  }

  const toArray = React.Children.toArray; // This is only used in DEV.
  const ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher;

  let pushCurrentDebugStack = stack => {};

  let popCurrentDebugStack = () => {};
  const newlineEatingTags = {
    listing: true,
    pre: true,
    textarea: true
  }; // We accept any tag to be rendered but since this gets injected into arbitrary
  // HTML, we want to make sure that it's a safe tag.
  // http://www.w3.org/TR/REC-xml/#NT-Name

  const VALID_TAG_REGEX = /^[a-zA-Z][a-zA-Z:_\.\-\d]*$/; // Simplified subset

  const validatedTagCache = {};

  function validateDangerousTag(tag) {
    if (!validatedTagCache.hasOwnProperty(tag)) {
      if (!VALID_TAG_REGEX.test(tag)) {
        {
          throw Error( formatProdErrorMessage(65, tag));
        }
      }

      validatedTagCache[tag] = true;
    }
  }

  const styleNameCache = {};

  const processStyleName = function (styleName) {
    if (styleNameCache.hasOwnProperty(styleName)) {
      return styleNameCache[styleName];
    }

    const result = hyphenateStyleName(styleName);
    styleNameCache[styleName] = result;
    return result;
  };

  function createMarkupForStyles(styles) {
    let serialized = '';
    let delimiter = '';

    for (const styleName in styles) {
      if (!styles.hasOwnProperty(styleName)) {
        continue;
      }

      const isCustomProperty = styleName.indexOf('--') === 0;
      const styleValue = styles[styleName];

      if (styleValue != null) {
        serialized += delimiter + (isCustomProperty ? styleName : processStyleName(styleName)) + ':';
        serialized += dangerousStyleValue(styleName, styleValue, isCustomProperty);
        delimiter = ';';
      }
    }

    return serialized || null;
  }

  function shouldConstruct(Component) {
    return Component.prototype && Component.prototype.isReactComponent;
  }

  function getNonChildrenInnerMarkup(props) {
    const innerHTML = props.dangerouslySetInnerHTML;

    if (innerHTML != null) {
      if (innerHTML.__html != null) {
        return innerHTML.__html;
      }
    } else {
      const content = props.children;

      if (typeof content === 'string' || typeof content === 'number') {
        return escapeTextForBrowser(content);
      }
    }

    return null;
  }

  function flattenTopLevelChildren(children) {
    if (!React.isValidElement(children)) {
      return toArray(children);
    }

    const element = children;

    if (element.type !== REACT_FRAGMENT_TYPE) {
      return [element];
    }

    const fragmentChildren = element.props.children;

    if (!React.isValidElement(fragmentChildren)) {
      return toArray(fragmentChildren);
    }

    const fragmentChildElement = fragmentChildren;
    return [fragmentChildElement];
  }

  function flattenOptionChildren(children) {
    if (children === undefined || children === null) {
      return children;
    }

    let content = ''; // Flatten children and warn if they aren't strings or numbers;
    // invalid types are ignored.

    React.Children.forEach(children, function (child) {
      if (child == null) {
        return;
      }

      content += child;
    });
    return content;
  }

  const hasOwnProperty$1 = Object.prototype.hasOwnProperty;
  const STYLE = 'style';
  const RESERVED_PROPS = {
    children: null,
    dangerouslySetInnerHTML: null,
    suppressContentEditableWarning: null,
    suppressHydrationWarning: null
  };

  function createOpenTagMarkup(tagVerbatim, tagLowercase, props, namespace, makeStaticMarkup, isRootElement) {
    let ret = '<' + tagVerbatim;
    const isCustomComponent$1 = isCustomComponent(tagLowercase, props);

    for (const propKey in props) {
      if (!hasOwnProperty$1.call(props, propKey)) {
        continue;
      }

      let propValue = props[propKey];

      if (propValue == null) {
        continue;
      }

      if (propKey === STYLE) {
        propValue = createMarkupForStyles(propValue);
      }

      let markup = null;

      if (isCustomComponent$1) {
        if (!RESERVED_PROPS.hasOwnProperty(propKey)) {
          markup = createMarkupForCustomAttribute(propKey, propValue);
        }
      } else {
        markup = createMarkupForProperty(propKey, propValue);
      }

      if (markup) {
        ret += ' ' + markup;
      }
    } // For static pages, no need to put React ID and checksum. Saves lots of
    // bytes.


    if (makeStaticMarkup) {
      return ret;
    }

    if (isRootElement) {
      ret += ' ' + createMarkupForRoot();
    }

    return ret;
  }

  function validateRenderResult(child, type) {
    if (child === undefined) {
      {
        {
          throw Error( formatProdErrorMessage(152, getComponentName(type) || 'Component'));
        }
      }
    }
  }

  function resolve(child, context, threadID) {
    while (React.isValidElement(child)) {
      // Safe because we just checked it's an element.
      const element = child;
      const Component = element.type;

      if (typeof Component !== 'function') {
        break;
      }

      processChild(element, Component);
    } // Extra closure so queue and replace can be captured properly


    function processChild(element, Component) {
      const isClass = shouldConstruct(Component);
      const publicContext = processContext(Component, context, threadID, isClass);
      let queue = [];
      let replace = false;
      const updater = {
        isMounted: function (publicInstance) {
          return false;
        },
        enqueueForceUpdate: function (publicInstance) {
          if (queue === null) {
            return null;
          }
        },
        enqueueReplaceState: function (publicInstance, completeState) {
          replace = true;
          queue = [completeState];
        },
        enqueueSetState: function (publicInstance, currentPartialState) {
          if (queue === null) {
            return null;
          }

          queue.push(currentPartialState);
        }
      };
      let inst;

      if (isClass) {
        inst = new Component(element.props, publicContext, updater);

        if (typeof Component.getDerivedStateFromProps === 'function') {

          const partialState = Component.getDerivedStateFromProps.call(null, element.props, inst.state);

          if (partialState != null) {
            inst.state = _assign({}, inst.state, partialState);
          }
        }
      } else {

        const componentIdentity = {};
        prepareToUseHooks(componentIdentity);
        inst = Component(element.props, publicContext, updater);
        inst = finishHooks(Component, element.props, inst, publicContext);
        // Otherwise, we also do the unfortunate dynamic checks.


        if ( inst == null || inst.render == null) {
          child = inst;
          validateRenderResult(child, Component);
          return;
        }
      }

      inst.props = element.props;
      inst.context = publicContext;
      inst.updater = updater;
      let initialState = inst.state;

      if (initialState === undefined) {
        inst.state = initialState = null;
      }

      if (typeof inst.UNSAFE_componentWillMount === 'function' || typeof inst.componentWillMount === 'function') {
        if (typeof inst.componentWillMount === 'function') {
          // Unsafe lifecycles should not be invoked for any component with the new gDSFP.


          if (typeof Component.getDerivedStateFromProps !== 'function') {
            inst.componentWillMount();
          }
        }

        if (typeof inst.UNSAFE_componentWillMount === 'function' && typeof Component.getDerivedStateFromProps !== 'function') {
          // In order to support react-lifecycles-compat polyfilled components,
          // Unsafe lifecycles should not be invoked for any component with the new gDSFP.
          inst.UNSAFE_componentWillMount();
        }

        if (queue.length) {
          const oldQueue = queue;
          const oldReplace = replace;
          queue = null;
          replace = false;

          if (oldReplace && oldQueue.length === 1) {
            inst.state = oldQueue[0];
          } else {
            let nextState = oldReplace ? oldQueue[0] : inst.state;
            let dontMutate = true;

            for (let i = oldReplace ? 1 : 0; i < oldQueue.length; i++) {
              const partial = oldQueue[i];
              const partialState = typeof partial === 'function' ? partial.call(inst, nextState, element.props, publicContext) : partial;

              if (partialState != null) {
                if (dontMutate) {
                  dontMutate = false;
                  nextState = _assign({}, nextState, partialState);
                } else {
                  _assign(nextState, partialState);
                }
              }
            }

            inst.state = nextState;
          }
        } else {
          queue = null;
        }
      }

      child = inst.render();

      validateRenderResult(child, Component);
      let childContext;

      {
        if (typeof inst.getChildContext === 'function') {
          const childContextTypes = Component.childContextTypes;

          if (typeof childContextTypes === 'object') {
            childContext = inst.getChildContext();

            for (const contextKey in childContext) {
              if (!(contextKey in childContextTypes)) {
                {
                  throw Error( formatProdErrorMessage(108, getComponentName(Component) || 'Unknown', contextKey));
                }
              }
            }
          }
        }

        if (childContext) {
          context = _assign({}, context, childContext);
        }
      }
    }

    return {
      child,
      context
    };
  }

  let ReactDOMServerRenderer = /*#__PURE__*/function () {
    // TODO: type this more strictly:
    // DEV-only
    function ReactDOMServerRenderer(children, makeStaticMarkup, options) {
      const flatChildren = flattenTopLevelChildren(children);
      const topFrame = {
        type: null,
        // Assume all trees start in the HTML namespace (not totally true, but
        // this is what we did historically)
        domNamespace: Namespaces.html,
        children: flatChildren,
        childIndex: 0,
        context: emptyObject,
        footer: ''
      };

      this.threadID = allocThreadID();
      this.stack = [topFrame];
      this.exhausted = false;
      this.currentSelectValue = null;
      this.previousWasTextNode = false;
      this.makeStaticMarkup = makeStaticMarkup;
      this.suspenseDepth = 0; // Context (new API)

      this.contextIndex = -1;
      this.contextStack = [];
      this.contextValueStack = []; // useOpaqueIdentifier ID

      this.uniqueID = 0;
      this.identifierPrefix = options && options.identifierPrefix || '';
    }

    var _proto = ReactDOMServerRenderer.prototype;

    _proto.destroy = function destroy() {
      if (!this.exhausted) {
        this.exhausted = true;
        this.clearProviders();
        freeThreadID(this.threadID);
      }
    }
    /**
     * Note: We use just two stacks regardless of how many context providers you have.
     * Providers are always popped in the reverse order to how they were pushed
     * so we always know on the way down which provider you'll encounter next on the way up.
     * On the way down, we push the current provider, and its context value *before*
     * we mutated it, onto the stacks. Therefore, on the way up, we always know which
     * provider needs to be "restored" to which value.
     * https://github.com/facebook/react/pull/12985#issuecomment-396301248
     */
    ;

    _proto.pushProvider = function pushProvider(provider) {
      const index = ++this.contextIndex;
      const context = provider.type._context;
      const threadID = this.threadID;
      validateContextBounds(context, threadID);
      const previousValue = context[threadID]; // Remember which value to restore this context to on our way up.

      this.contextStack[index] = context;
      this.contextValueStack[index] = previousValue;


      context[threadID] = provider.props.value;
    };

    _proto.popProvider = function popProvider(provider) {
      const index = this.contextIndex;

      const context = this.contextStack[index];
      const previousValue = this.contextValueStack[index]; // "Hide" these null assignments from Flow by using `any`
      // because conceptually they are deletions--as long as we
      // promise to never access values beyond `this.contextIndex`.

      this.contextStack[index] = null;
      this.contextValueStack[index] = null;

      this.contextIndex--; // Restore to the previous value we stored as we were walking down.
      // We've already verified that this context has been expanded to accommodate
      // this thread id, so we don't need to do it again.

      context[this.threadID] = previousValue;
    };

    _proto.clearProviders = function clearProviders() {
      // Restore any remaining providers on the stack to previous values
      for (let index = this.contextIndex; index >= 0; index--) {
        const context = this.contextStack[index];
        const previousValue = this.contextValueStack[index];
        context[this.threadID] = previousValue;
      }
    };

    _proto.read = function read(bytes) {
      if (this.exhausted) {
        return null;
      }

      const prevPartialRenderer = currentPartialRenderer;
      setCurrentPartialRenderer(this);
      const prevDispatcher = ReactCurrentDispatcher$1.current;
      ReactCurrentDispatcher$1.current = Dispatcher;

      try {
        // Markup generated within <Suspense> ends up buffered until we know
        // nothing in that boundary suspended
        const out = [''];
        let suspended = false;

        while (out[0].length < bytes) {
          if (this.stack.length === 0) {
            this.exhausted = true;
            freeThreadID(this.threadID);
            break;
          }

          const frame = this.stack[this.stack.length - 1];

          if (suspended || frame.childIndex >= frame.children.length) {
            const footer = frame.footer;

            if (footer !== '') {
              this.previousWasTextNode = false;
            }

            this.stack.pop();

            if (frame.type === 'select') {
              this.currentSelectValue = null;
            } else if (frame.type != null && frame.type.type != null && frame.type.type.$$typeof === REACT_PROVIDER_TYPE) {
              const provider = frame.type;
              this.popProvider(provider);
            } else if (frame.type === REACT_SUSPENSE_TYPE) {
              this.suspenseDepth--;
              const buffered = out.pop();

              if (suspended) {
                suspended = false; // If rendering was suspended at this boundary, render the fallbackFrame

                const fallbackFrame = frame.fallbackFrame;

                if (!fallbackFrame) {
                  {
                    throw Error(false ? "ReactDOMServer did not find an internal fallback frame for Suspense. This is a bug in React. Please file an issue." : formatProdErrorMessage(303));
                  }
                }

                this.stack.push(fallbackFrame);
                out[this.suspenseDepth] += '<!--$!-->'; // Skip flushing output since we're switching to the fallback

                continue;
              } else {
                out[this.suspenseDepth] += buffered;
              }
            } // Flush output


            out[this.suspenseDepth] += footer;
            continue;
          }

          const child = frame.children[frame.childIndex++];
          let outBuffer = '';

          if (false) ;

          try {
            outBuffer += this.render(child, frame.context, frame.domNamespace);
          } catch (err) {
            if (err != null && typeof err.then === 'function') {
              if (enableSuspenseServerRenderer) {
                if (!(this.suspenseDepth > 0)) {
                  {
                    throw Error(false ? "A React component suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display." : formatProdErrorMessage(342));
                  }
                }

                suspended = true;
              }
            } else {
              throw err;
            }
          } finally {
            if (false) ;
          }

          if (out.length <= this.suspenseDepth) {
            out.push('');
          }

          out[this.suspenseDepth] += outBuffer;
        }

        return out[0];
      } finally {
        ReactCurrentDispatcher$1.current = prevDispatcher;
        setCurrentPartialRenderer(prevPartialRenderer);
        resetHooksState();
      }
    };

    _proto.render = function render(child, context, parentNamespace) {
      if (typeof child === 'string' || typeof child === 'number') {
        const text = '' + child;

        if (text === '') {
          return '';
        }

        if (this.makeStaticMarkup) {
          return escapeTextForBrowser(text);
        }

        if (this.previousWasTextNode) {
          return '<!-- -->' + escapeTextForBrowser(text);
        }

        this.previousWasTextNode = true;
        return escapeTextForBrowser(text);
      } else {
        let nextChild;

        var _resolve = resolve(child, context, this.threadID);

        nextChild = _resolve.child;
        context = _resolve.context;

        if (nextChild === null || nextChild === false) {
          return '';
        } else if (!React.isValidElement(nextChild)) {
          if (nextChild != null && nextChild.$$typeof != null) {
            // Catch unexpected special types early.
            const $$typeof = nextChild.$$typeof;

            if (!($$typeof !== REACT_PORTAL_TYPE)) {
              {
                throw Error( formatProdErrorMessage(257));
              }
            } // Catch-all to prevent an infinite loop if React.Children.toArray() supports some new type.


            {
              {
                throw Error( formatProdErrorMessage(258, $$typeof.toString()));
              }
            }
          }

          const nextChildren = toArray(nextChild);
          const frame = {
            type: null,
            domNamespace: parentNamespace,
            children: nextChildren,
            childIndex: 0,
            context: context,
            footer: ''
          };

          this.stack.push(frame);
          return '';
        } // Safe because we just checked it's an element.


        const nextElement = nextChild;
        const elementType = nextElement.type;

        if (typeof elementType === 'string') {
          return this.renderDOM(nextElement, context, parentNamespace);
        }

        switch (elementType) {
          // TODO: LegacyHidden acts the same as a fragment. This only works
          // because we currently assume that every instance of LegacyHidden is
          // accompanied by a host component wrapper. In the hidden mode, the host
          // component is given a `hidden` attribute, which ensures that the
          // initial HTML is not visible. To support the use of LegacyHidden as a
          // true fragment, without an extra DOM node, we would have to hide the
          // initial HTML in some other way.
          case REACT_LEGACY_HIDDEN_TYPE:
          case REACT_DEBUG_TRACING_MODE_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_SUSPENSE_LIST_TYPE:
          case REACT_FRAGMENT_TYPE:
            {
              const nextChildren = toArray(nextChild.props.children);
              const frame = {
                type: null,
                domNamespace: parentNamespace,
                children: nextChildren,
                childIndex: 0,
                context: context,
                footer: ''
              };

              this.stack.push(frame);
              return '';
            }

          case REACT_SUSPENSE_TYPE:
            {
              {
                const fallback = nextChild.props.fallback;

                if (fallback === undefined) {
                  // If there is no fallback, then this just behaves as a fragment.
                  const nextChildren = toArray(nextChild.props.children);
                  const frame = {
                    type: null,
                    domNamespace: parentNamespace,
                    children: nextChildren,
                    childIndex: 0,
                    context: context,
                    footer: ''
                  };

                  this.stack.push(frame);
                  return '';
                }

                const fallbackChildren = toArray(fallback);
                const nextChildren = toArray(nextChild.props.children);
                const fallbackFrame = {
                  type: null,
                  domNamespace: parentNamespace,
                  children: fallbackChildren,
                  childIndex: 0,
                  context: context,
                  footer: '<!--/$-->'
                };
                const frame = {
                  fallbackFrame,
                  type: REACT_SUSPENSE_TYPE,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: '<!--/$-->'
                };

                this.stack.push(frame);
                this.suspenseDepth++;
                return '<!--$-->';
              }
            }
          // eslint-disable-next-line-no-fallthrough

          case REACT_SCOPE_TYPE:
            {

              {
                {
                  throw Error( formatProdErrorMessage(343));
                }
              }
            }
        }

        if (typeof elementType === 'object' && elementType !== null) {
          switch (elementType.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              {
                const element = nextChild;
                let nextChildren;
                const componentIdentity = {};
                prepareToUseHooks(componentIdentity);
                nextChildren = elementType.render(element.props, element.ref);
                nextChildren = finishHooks(elementType.render, element.props, nextChildren, element.ref);
                nextChildren = toArray(nextChildren);
                const frame = {
                  type: null,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: ''
                };

                this.stack.push(frame);
                return '';
              }

            case REACT_MEMO_TYPE:
              {
                const element = nextChild;
                const nextChildren = [React.createElement(elementType.type, _assign({
                  ref: element.ref
                }, element.props))];
                const frame = {
                  type: null,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: ''
                };

                this.stack.push(frame);
                return '';
              }

            case REACT_PROVIDER_TYPE:
              {
                const provider = nextChild;
                const nextProps = provider.props;
                const nextChildren = toArray(nextProps.children);
                const frame = {
                  type: provider,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: ''
                };

                this.pushProvider(provider);
                this.stack.push(frame);
                return '';
              }

            case REACT_CONTEXT_TYPE:
              {
                let reactContext = nextChild.type; // The logic below for Context differs depending on PROD or DEV mode. In

                const nextProps = nextChild.props;
                const threadID = this.threadID;
                validateContextBounds(reactContext, threadID);
                const nextValue = reactContext[threadID];
                const nextChildren = toArray(nextProps.children(nextValue));
                const frame = {
                  type: nextChild,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: ''
                };

                this.stack.push(frame);
                return '';
              }
            // eslint-disable-next-line-no-fallthrough

            case REACT_FUNDAMENTAL_TYPE:
              {

                {
                  {
                    throw Error( formatProdErrorMessage(338));
                  }
                }
              }
            // eslint-disable-next-line-no-fallthrough

            case REACT_LAZY_TYPE:
              {
                const element = nextChild;
                const lazyComponent = nextChild.type; // Attempt to initialize lazy component regardless of whether the
                // suspense server-side renderer is enabled so synchronously
                // resolved constructors are supported.

                const payload = lazyComponent._payload;
                const init = lazyComponent._init;
                const result = init(payload);
                const nextChildren = [React.createElement(result, _assign({
                  ref: element.ref
                }, element.props))];
                const frame = {
                  type: null,
                  domNamespace: parentNamespace,
                  children: nextChildren,
                  childIndex: 0,
                  context: context,
                  footer: ''
                };

                this.stack.push(frame);
                return '';
              }
          }
        }

        let info = '';

        {
          {
            throw Error( formatProdErrorMessage(130, elementType == null ? elementType : typeof elementType, info));
          }
        }
      }
    };

    _proto.renderDOM = function renderDOM(element, context, parentNamespace) {
      const tag = element.type.toLowerCase();
      let namespace = parentNamespace;

      if (parentNamespace === Namespaces.html) {
        namespace = getIntrinsicNamespace(tag);
      }

      validateDangerousTag(tag);
      let props = element.props;

      if (tag === 'input') {

        props = _assign({
          type: undefined
        }, props, {
          defaultChecked: undefined,
          defaultValue: undefined,
          value: props.value != null ? props.value : props.defaultValue,
          checked: props.checked != null ? props.checked : props.defaultChecked
        });
      } else if (tag === 'textarea') {

        let initialValue = props.value;

        if (initialValue == null) {
          let defaultValue = props.defaultValue; // TODO (yungsters): Remove support for children content in <textarea>.

          let textareaChildren = props.children;

          if (textareaChildren != null) {

            if (!(defaultValue == null)) {
              {
                throw Error( formatProdErrorMessage(92));
              }
            }

            if (Array.isArray(textareaChildren)) {
              if (!(textareaChildren.length <= 1)) {
                {
                  throw Error( formatProdErrorMessage(93));
                }
              }

              textareaChildren = textareaChildren[0];
            }

            defaultValue = '' + textareaChildren;
          }

          if (defaultValue == null) {
            defaultValue = '';
          }

          initialValue = defaultValue;
        }

        props = _assign({}, props, {
          value: undefined,
          children: '' + initialValue
        });
      } else if (tag === 'select') {

        this.currentSelectValue = props.value != null ? props.value : props.defaultValue;
        props = _assign({}, props, {
          value: undefined
        });
      } else if (tag === 'option') {
        let selected = null;
        const selectValue = this.currentSelectValue;
        const optionChildren = flattenOptionChildren(props.children);

        if (selectValue != null) {
          let value;

          if (props.value != null) {
            value = props.value + '';
          } else {
            value = optionChildren;
          }

          selected = false;

          if (Array.isArray(selectValue)) {
            // multiple
            for (let j = 0; j < selectValue.length; j++) {
              if ('' + selectValue[j] === value) {
                selected = true;
                break;
              }
            }
          } else {
            selected = '' + selectValue === value;
          }

          props = _assign({
            selected: undefined,
            children: undefined
          }, props, {
            selected: selected,
            children: optionChildren
          });
        }
      }

      assertValidProps(tag, props);
      let out = createOpenTagMarkup(element.type, tag, props, namespace, this.makeStaticMarkup, this.stack.length === 1);
      let footer = '';

      if (omittedCloseTags.hasOwnProperty(tag)) {
        out += '/>';
      } else {
        out += '>';
        footer = '</' + element.type + '>';
      }

      let children;
      const innerMarkup = getNonChildrenInnerMarkup(props);

      if (innerMarkup != null) {
        children = [];

        if (newlineEatingTags.hasOwnProperty(tag) && innerMarkup.charAt(0) === '\n') {
          // text/html ignores the first character in these tags if it's a newline
          // Prefer to break application/xml over text/html (for now) by adding
          // a newline specifically to get eaten by the parser. (Alternately for
          // textareas, replacing "^\n" with "\r\n" doesn't get eaten, and the first
          // \r is normalized out by HTMLTextAreaElement#value.)
          // See: <http://www.w3.org/TR/html-polyglot/#newlines-in-textarea-and-pre>
          // See: <http://www.w3.org/TR/html5/syntax.html#element-restrictions>
          // See: <http://www.w3.org/TR/html5/syntax.html#newlines>
          // See: Parsing of "textarea" "listing" and "pre" elements
          //  from <http://www.w3.org/TR/html5/syntax.html#parsing-main-inbody>
          out += '\n';
        }

        out += innerMarkup;
      } else {
        children = toArray(props.children);
      }

      const frame = {
        domNamespace: getChildNamespace(parentNamespace, element.type),
        type: tag,
        children,
        childIndex: 0,
        context: context,
        footer: footer
      };

      this.stack.push(frame);
      this.previousWasTextNode = false;
      return out;
    };

    return ReactDOMServerRenderer;
  }();

  /**
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  /**
   * Render a ReactElement to its initial HTML. This should only be used on the
   * server.
   * See https://reactjs.org/docs/react-dom-server.html#rendertostring
   */

  function renderToString(element, options) {
    const renderer = new ReactDOMServerRenderer(element, false, options);

    try {
      const markup = renderer.read(Infinity);
      return markup;
    } finally {
      renderer.destroy();
    }
  }
  /**
   * Similar to renderToString, except this doesn't create extra DOM attributes
   * such as data-react-id that React uses internally.
   * See https://reactjs.org/docs/react-dom-server.html#rendertostaticmarkup
   */

  function renderToStaticMarkup(element, options) {
    const renderer = new ReactDOMServerRenderer(element, true, options);

    try {
      const markup = renderer.read(Infinity);
      return markup;
    } finally {
      renderer.destroy();
    }
  }

  function renderToNodeStream() {
    {
      {
        throw Error( formatProdErrorMessage(207));
      }
    }
  }

  function renderToStaticNodeStream() {
    {
      {
        throw Error( formatProdErrorMessage(208));
      }
    }
  }

  exports.renderToNodeStream = renderToNodeStream;
  exports.renderToStaticMarkup = renderToStaticMarkup;
  exports.renderToStaticNodeStream = renderToStaticNodeStream;
  exports.renderToString = renderToString;
  exports.version = ReactVersion;

})));})();
