/** @license React vundefined
 * react-noop-renderer-flight-client.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

var flightModules = require('react-noop-renderer/flight-modules');
var ReactFlightClient = require('react-client/flight');

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */

const _ReactFlightClient = ReactFlightClient({
  supportsBinaryStreams: false,

  resolveModuleReference(idx) {
    return idx;
  },

  preloadModule(idx) {},

  requireModule(idx) {
    return flightModules.readModule(idx);
  },

  parseModel(response, json) {
    return JSON.parse(json, response._fromJSON);
  }

}),
      createResponse = _ReactFlightClient.createResponse,
      processStringChunk = _ReactFlightClient.processStringChunk,
      close = _ReactFlightClient.close;

function read(source) {
  const response = createResponse(source);

  for (let i = 0; i < source.length; i++) {
    processStringChunk(response, source[i], 0);
  }

  close(response);
  return response.readRoot();
}

exports.read = read;
