/** @license React vundefined
 * react-noop-renderer-server.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

var ReactFizzServer = require('react-server');

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
const ReactNoopServer = ReactFizzServer({
  scheduleWork(callback) {
    callback();
  },

  beginWriting(destination) {},

  writeChunk(destination, buffer) {
    destination.push(JSON.parse(Buffer.from(buffer).toString('utf8')));
  },

  completeWriting(destination) {},

  close(destination) {},

  flushBuffered(destination) {},

  convertStringToBuffer(content) {
    return Buffer.from(content, 'utf8');
  },

  formatChunkAsString(type, props) {
    return JSON.stringify({
      type,
      props
    });
  },

  formatChunk(type, props) {
    return Buffer.from(JSON.stringify({
      type,
      props
    }), 'utf8');
  }

});

function render(children) {
  const destination = [];
  const request = ReactNoopServer.createRequest(children, destination);
  ReactNoopServer.startWork(request);
  return destination;
}

exports.render = render;
